;;joe's nifty sqlmode additions

(add-hook 'sql-mode-hook 
	  (function (lambda ()
		      (define-key sql-mode-map "\C-x\C-e" 'sql-send-region)
		      (define-key sql-mode-map "\C-c\C-t" 'insert-table-name)
		      (define-key sql-mode-map "\C-c\#" 'insert-fund-num)
		      (define-key sql-mode-map "\C-c\'" 'insert-fundname))))

(defun insert-table-name (&optional where)
  (interactive "p")
  (let* ((start (progn (backward-sexp 1) (point)))
	 (end (progn (forward-sexp 1) (point)))
	 (tbl (buffer-substring start end))
	 (my-tbl (chop (exec-to-string (concat "get_tbl " tbl)))))
    (delete-region start end)
    (insert my-tbl))) 

(defun insert-fund-num (&optional where)
  (interactive "p")
  (let* ((start (progn (backward-sexp 1) (point)))
	 (end (progn (forward-sexp 1) (point)))
	 (fundname (buffer-substring start end))
	 (fundnum (exec-to-string (concat "fundnum " fundname))))
    (string-match "[0-9]+" fundnum)
    (delete-region start end)
    (insert (substring fundnum (match-beginning 0) (match-end 0)))))

(defun insert-fundname (&optional where)
  (interactive "p")
  (let* ((start (progn (backward-sexp 1) (point)))
	 (end (progn (forward-sexp 1) (point)))
	 (fundnum (buffer-substring start end))
	 (fundname (exec-to-string (concat "fundname " fundnum))))
    (delete-region start end)
    (insert (concat "'" (strip-space (third (string-split "\n" fundname)))
		    "'"))))
    
(defun chop (string)
  (substring string 0 (- (length string) 1)))

(defun strip-space (string)
  (string-match "[ \t\n]*$" string)
  (let ((string (substring string 0 (match-beginning 0))))
    (string-match "^[ \t\n]*" string)
    (substring string (match-end 0) (length string))))

(defun string-split (delim string)
  "Split STRING into a list of strings breaking at DELIM.  This is
inspired by the Perl function split."
  (let ((return-list nil)
	(search-start 0)
	(found 0))
    (while (setq found (string-match delim string search-start))
      (setq return-list (cons (substring string search-start found)
			      return-list))
      (setq search-start (match-end 0)))

    (if (<= search-start (length string))
	(setq return-list (cons (substring string search-start) return-list)))
    ;; Now reverse the list produced, to put it in the right order
    (setq return-list (nreverse return-list))
    return-list))