;; jbank@alum.mit.edu
;; 10/2000
;;
;; If you want to use my .emacs file and modules, you should do the following:
;;  1.) Modify the 4 variables below.
;;  2.) Optionally comment out the (load "preferences") line and replace
;;      it with a line that loads your preferences
;;  3.) Optionally replace the automatic loading of all modules with a specifi
;;      list of modules to load.

(defvar username (user-login-name))
(defvar user-elisp-directory (concat "~" username "/elisp"))
(defvar useremail (concat username "@" system-name))
(defvar userfullname (user-full-name))

;;Stuff for me in particular
(if (equal username "jbank") 
    (setq useremail "jbank@alum.mit.edu"
          userfullname "Joseph A. Bank"))

;; Use this var if you want to know if .emacs was loaded.
(defvar initialized nil)

(if (not initialized)
    (setq load-path
      (append
       (list user-elisp-directory
             (concat user-elisp-directory "/downloaded")
             (concat user-elisp-directory "/mycode"))
       load-path)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Load my modules.  i.e. everything in ~/elisp/mycode
;; Modules provide some additional functionality, either via a new M-x command,
;; some new key binding, or something that happens automatically.
;; Feel free to modify this to load a specific list of modules.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(let ((files (directory-files (concat user-elisp-directory "/mycode/") t ".*\.el$")))
  (mapcar '(lambda (file) (load file)) files))

;example of explicit list, uncomment and edit
;(let ((files '("colorize" "truncate" "shell-password-cache" "nshell")))
;  (mapcar '(lambda (file) (load file)) files))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Load my preferences.  This is for things like my colors, key bindings,
;; font lock settings, etc.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(load "preferences")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Ok, everything has been loaded
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(setq initialized t)