;; jbank@alum.mit.edu
;; 10/2000
;;
;; Various elisp utilities.
;;

(defun string-split (delim string)
  "Split STRING into a list of strings breaking at DELIM.  This is
inspired by the Perl function split."
  (let ((return-list nil)
	(search-start 0)
	(found 0))
    (while (setq found (string-match delim string search-start))
      (setq return-list (cons (substring string search-start found)
			      return-list))
      (setq search-start (match-end 0)))

    (if (<= search-start (length string))
	(setq return-list (cons (substring string search-start) return-list)))
    ;; Now reverse the list produced, to put it in the right order
    (setq return-list (nreverse return-list))
    return-list))

(defun third (x)
  (car (cdr (cdr x))))

(defun locate-file (file path &optional suffix)
  "Return the full path name of the file file."
  (interactive "sLocate file: ")
  (catch 'answer
    (mapcar
     '(lambda (dir)
	(mapcar
	 '(lambda (suf)
	    (let ((try (expand-file-name (concat file suf) dir)))
              (message "Foo %s" try)
	      (and (file-readable-p try)
		   (null (file-directory-p try))
		   (progn
		     (message "File is file %s" try)
		     (throw 'answer try)))))
	 (string-split ":" (if suffix suffix ""))))
     path)
    (message "No file %s in search path" file)
    nil))

(provide 'joes-utils)