;; jbank@alum.mit.edu
;; 10/2000
;;
;; Provides key bindings and functions for moving around the mark ring.
;; Exports: prev-mark, next-mark
;; bindings: M-p, M-n

;;for reference, the original is in simple.el
(defun my-set-mark-command (arg)
  "See doc for set-mark-command"
  (interactive "P")
  (if (null arg)
      (progn
	(set-mark-command arg))
    (if (< arg 0)
        (set-mark-command arg)
      (progn
        (rev-pop-mark)
        (goto-char (mark t))))))

;;based on pop-mark in simple.el
(defun rev-pop-mark ()
  (if mark-ring
      (let ((mark-ring-last (car (reverse mark-ring))))
	(setq mark-ring (cons (copy-marker (mark-marker)) mark-ring))
	(set-marker (mark-marker) (+ 0 mark-ring-last) (current-buffer))
	(deactivate-mark)
	(move-marker mark-ring-last nil)
	(if (null (mark t)) (ding))
	(setq mark-ring (reverse (cdr (reverse mark-ring)))))))

(defun prev-mark ()
  (interactive)
  (my-set-mark-command -1))

(defun next-mark ()
  (interactive)
  (my-set-mark-command 1))


(global-set-key "\M-p" 'prev-mark)
(global-set-key "\M-n" 'next-mark)
