;; jbank@alum.mit.edu
;; 10/2000
;;
;; Provide simple function to create named shell buffers.
;; Very useful.
;;
;; Exports: nshell

(defun nshell (command-line)
  (interactive (list (read-from-minibuffer "New shell name: ")))

  (if (not (comint-check-proc (format "*%sshell*" command-line)))
      (let* ((prog (or explicit-shell-file-name
                       (getenv "ESHELL")
                       (getenv "SHELL")
                       "/bin/sh"))
             (name (file-name-nondirectory prog))
             (startfile (concat "~/.emacs_" name))
             (xargs-name (intern-soft (concat "explicit-" name "-args"))))
        (set-buffer (apply 'make-comint (format "%sshell" command-line) prog
                           (if (file-exists-p startfile) startfile)
                           (if (and xargs-name (boundp xargs-name))
                               (symbol-value xargs-name)
                             '("-i"))))
        (shell-mode)))
  (switch-to-buffer (format "*%sshell*" command-line)))