;; jbank@alum.mit.edu
;; 10/2000
;;
;; Some simple buffer positioning commands and bindings.
;;
;; Exports: center-to-top, next-def-to-top, prev-def-to-top, split-small
;; bindings: C-x 9, C-x l, C-x p, M-l, C-cc

(defun center-to-top ()
  "pull current cursor postion to top of screen"
  (interactive)
  (recenter 0))

(defun next-def-to-top ()
  "pull the next definition to the top of the screen"
  (interactive)
  (end-of-defun 2)
  (beginning-of-defun)
  (center-to-top))

(defun prev-def-to-top ()
  "pull the next definition to the top of the screen"
  (interactive)
  (beginning-of-defun)
  (center-to-top))

(defun split-small ()
  "split the screen with-bottom small"
  (interactive)
  (split-window-vertically -10))

(global-set-key "\C-x\9" 'split-small)
(global-set-key "\C-x\l" 'next-def-to-top)
(global-set-key "\C-x\p" 'prev-def-to-top)
(global-set-key "\M-l" 'goto-line)
(global-set-key "\C-cc" 'compare-windows)
